#
# spawn from iex shell
# pp = spawn(Salutator, :run, [])
# then use pp this way
# send(pp, {:hi, "Dave"})
# and see the IO.puts output


defmodule Salutator do
  def run do
    receive do
      {:hi, name} ->    
          IO.puts "Hi, #{name}"
          # note without this loop the server ends... you get one
          # message response and its over
          run()
      {:hello, name} -> 
          IO.puts "Hello, #{name}"
          run()
      {:stop, _} -> 
          IO.puts "ok, stopping"
      {_, name} ->      
          IO.puts "Howdy, #{name}"
          run()
    end
  end
end


