
defmodule Config do  
  def start_server(opts \\ []) do  # allow default params
    timeout = Keyword.get(opts, :timeout, 5000)
    retries = Keyword.get(opts, :retries, 3) 
    verbose = Keyword.get(opts, :verbose, false)

    IO.puts "Starting server with:"    
    IO.puts "Timeout: #{timeout}"    
    IO.puts "Retries: #{retries}"    
    IO.puts "Verbose: #{verbose}"  
  end
end

Config.start_server( ) # Uses default values
Config.start_server(timeout: 3000, verbose: true)

